class StructuralAttributeBuilderFunctionsQueryBuilder extends GeneralFunctionsQueryBuilder {
  constructor(elements) {
    super(elements);
    this.elements = elements;

    document.querySelectorAll('[data-structural-attr-modal-action-button]').forEach(button => {
      button.addEventListener('click', () => {
        this.actionButtonInStrucAttrModalHandler(button.dataset.structuralAttrModalActionButton);
      });
    });
    document.querySelector('.ent-type-selection-action[data-ent-type="any"]').addEventListener('click', () => {
      this.queryChipFactory('start-empty-entity', 'Entity Start', '<ent>');
      this.queryChipFactory('end-entity', 'Entity End', '</ent>');
      this.elements.structuralAttrModal.close();
    });
    document.querySelector('.ent-type-selection-action[data-ent-type="english"]').addEventListener('change', (event) => {
      this.queryChipFactory('start-entity', `Entity Type=${event.target.value}`, `<ent_type="${event.target.value}">`);
      this.queryChipFactory('end-entity', 'Entity End', '</ent_type>');
      this.elements.structuralAttrModal.close();
    });


  }

  actionButtonInStrucAttrModalHandler(action) {
    switch (action) {
      case 'sentence':
        this.queryChipFactory('start-sentence', 'Sentence Start', '<s>');
        this.queryChipFactory('end-sentence', 'Sentence End', '</s>');
        this.elements.structuralAttrModal.close();
        break;
      case 'entity':
        this.toggleClass(['entity-builder'], 'hide', 'toggle');
        this.toggleClass(['text-annotation-builder'], 'hide', 'add');
        break;
      case 'meta-data':
        this.toggleClass(['text-annotation-builder'], 'hide', 'toggle');
        this.toggleClass(['entity-builder'], 'hide', 'add');
        break;
      default:
        break;
    }
  }

}
